class EDGES_LIST[K]

inherit
	EDGES[K]
		redefine count
		end

creation make

feature {NONE} -- Creation

	make (m: like model) is
	do
		set_model (m)
		create edges.make (1, 0)
	end

feature {NONE} -- Representation

	edges: ARRAY[LINKED_LIST[VERTEX[K]]]

feature -- edge operations

	add (v1, v2: VERTEX[K]) is
	do
		edges.item (v1.index).add_last (v2)
	end

	remove (v1, v2: VERTEX[K]) is
	do
		edges.item (v1.index).remove (v2)
	end

	has (v1, v2: VERTEX[K]): BOOLEAN is
	do
		Result := edges.item (v1.index).fast_has (v2)
	end

	at (v: VERTEX[K]): ITERATOR[VERTEX[K]] is
	do
		Result := edges.item (v.index).get_new_iterator
	end

	count (v: VERTEX[K]): INTEGER is
	do
		Result := edges.item (v.index).count
	end

feature -- View

	on_model_change is
	local
		l: LINKED_LIST[VERTEX[K]]
	do
		if model.count > edges.count then
			create l.make
			edges.add_last (l)
		end
	ensure
		edges.count = model.count
	end

end -- class EDGES_LIST[K]
