class EDGES_MATRIX[K]

inherit
	EDGES[K]

creation make

feature {NONE} -- Creation

	make (m: like model) is
	do
		create edges.make (1, 1, 1, 1)
		set_model (m)
	end

feature {NONE} -- Representation

	edges: ARRAY2[BOOLEAN]

feature -- edge operations

	add (v1, v2: VERTEX[K]) is
	do
		edges.put (True, v1.index, v2.index)
	end

	remove (v1, v2: VERTEX[K]) is
	do
		edges.put (False, v1.index, v2.index)
	end

	has (v1, v2: VERTEX[K]): BOOLEAN is
	do
		Result := edges.item (v1.index, v2.index)
	end

	at (v: VERTEX[K]): ITERATOR[VERTEX[K]] is
	do
		create {ITERATOR_ADJACENTS[K]} Result.make (model, Current, v)
	end

feature -- View

	on_model_change is
	do
		edges.resize (1, model.count, 1, model.count)
	ensure
		model.count > 0 implies (edges.upper1 = model.count and edges.upper2 = model.count)
	end

end -- class EDGES_MATRIX[K]
