class SHORTEST_PATHS

creation make

feature {NONE}

	make is
	local
		graph_io: INPUT_OUTPUT[STRING]
		file: TEXT_FILE_WRITE
	do
		create file.connect_to ("grafo_grande.dot")
		create random.with_seed (2)
		generate
		-- scan
		-- graph_io.put (graph, file)
		queries
	end

	verts: ARRAY[VERTEX[STRING]]

	verts_count: INTEGER is 100

	edges_count: INTEGER is 10000

	max_weight: INTEGER is 1000

	queries_count: INTEGER is 100

	graph: WEIGHTED_UNDIRECTED_GRAPH[INTEGER, STRING, EDGES_LIST[STRING]]

	random: STD_RAND

	time: TIME

	generate is
	local
		i: INTEGER
		source, target, weight: INTEGER
	do
		create verts.make (1, 0)
		create graph.make
		from
			i := 1
		until
			i > verts_count
		loop
			graph.add (Void)
			verts.add_last (graph.last_vertex_added)
			i := i + 1
		end
		create random.make
		from
			i := 1
		until
			i > edges_count
		loop
			random.next
			source := random.last_integer (verts_count)
			random.next
			target := random.last_integer (verts_count)
			random.next
			weight := random.last_integer (max_weight)
			graph.add_edge (verts@source, verts@target, weight)
			i := i + 1
		end
	end

	queries is
	local
		i: INTEGER
		source, target, weight: INTEGER
	do
		print ("Comenzando Queries:%N")
		print_time
		from
			i := 1
		until
			i > queries_count
		loop
			random.next
			source := random.last_integer (verts_count)
			random.next
			target := random.last_integer (verts_count)
			if graph.exists_path (verts@source, verts@target) then
				weight := graph.shortest_path (verts@source, verts@target)
				print (weight.to_string + "%N")
				print_time
			end
			i := i + 1
		end
	end

	print_time is
	do
		--time.update
		--print (time.minute.to_string+ ":" + time.second.to_string+ "%N")
	end

	scan is
	local
		graph_io: INPUT_OUTPUT[STRING]
		file: TEXT_FILE_READ
	do
		create file.connect_to ("grafo_grande.dot")
		graph_io.read (file, graph)
	end

end -- class SHORTEST_PATHS