class TEST_SIMPLE

creation make

feature {NONE}

	make is
	local
		graph_io: SIMPLE_INPUT_OUTPUT
		file: TEXT_FILE_WRITE
	do
		create file.connect_to ("grafo_grande_simple.dot")
		create random.make
		generate
		graph_io.put (graph, file)
		queries
	end

	verts_count: INTEGER is 1000

	edges_count: INTEGER is 100000

	max_weight: INTEGER is 100

	queries_count: INTEGER is 100

	graph: SIMPLE_WEIGHTED_UNDIRECTED_GRAPH[SIMPLE_EDGES_MATRIX]

	random: STD_RAND

	time: TIME
	
	generate is
	local
		i: INTEGER
		source, target, weight: INTEGER
	do
		create verts.make (1, 0)
		create graph.simple_make (verts_count)
		create random.make
		from
			i := 1
		until
			i > edges_count
		loop
			random.next
			source := random.last_integer (verts_count)
			random.next
			target := random.last_integer (verts_count)
			random.next
			weight := random.last_integer (max_weight)
			graph.simple_add_edge (source, target, weight)
			i := i + 1
		end
	end

	queries is
	local
		i: INTEGER
		source, target, weight: INTEGER
	do
		print ("Comenzando Queries:%N")
		print_time
		from
			i := 1
		until
			i > queries_count
		loop
			random.next
			source := random.last_integer (verts_count)
			random.next
			target := random.last_integer (verts_count)
			if graph.simple_exists_path (source, target) then
				weight := graph.simple_shortest_path (source, target)
				print (weight.to_string + "%N")
				print_time
			end
			i := i + 1
		end
	end

	print_time is
	do
		time.update
		print (time.minute.to_string + ":" + time.second.to_string + "%N")
	end

end -- class TEST_SIMPLE
