class BIPARTITE_GRAPH[K, E->BIPARTITE_EDGES[K]]

inherit
	BIPARTITE_VERTICES[K]
	GRAPH[K, E]
		redefine is_valid_edge, couloring_number_greedy, is_bipartite,
adjacents
		end

feature -- Edges

	adjacents (v: VERTEX[K]): ITERATOR[VERTEX[K]] is
	do
		create {ITERATOR_ADJACENTS_BIPARTITE[K]}Result.make (Current, v)
	end

feature -- Algorithms

	couloring_number_greedy: INTEGER is
		-- Implementacion eficiente
	do
		if x.count > 0 and y.count > 0 then
			Result := 2
		elseif x.count > 0 or y.count > 0 then
			Result := 1
		else
			Result := 0
		end
	end

	is_bipartite: BOOLEAN is True
		-- Implementacion eficiente

feature -- Edges

	is_valid_edge (v1, v2: VERTEX[K]): BOOLEAN is
		-- Que siga siendo bipartito
	do
		Result := x.has_vertex (v1) and y.has_vertex (v2)
		Result := Result or y.has_vertex (v1) and x.has_vertex (v2)
	end

end -- class BIPARTITE_GRAPH[K, E]
