class DIRECTED_GRAPH[K, E->EDGES[K]]

inherit
	GRAPH[K, E]

creation make

feature -- operations

	add_edge(v1, v2: VERTEX[K]) is
	do
		if not edges.has (v1, v2) then
			edges.add (v1, v2)
		end
	end

	remove_edge(v1, v2: VERTEX[K]) is
	do
		if edges.has (v1, v2) then
			edges.remove (v1, v2)
		end
	end

	backward_adjacents (v: VERTEX[K]): ITERATOR[VERTEX[K]] is
		-- { w : are_adjacents (w, v) }
	require
		has_vertex(v)
	do
		create {ITERATOR_BACKWARD_ADJACENTS[K]} Result.make (Current, v)
	end

	topological_order: COLLECTION[VERTEX[K]] is
		-- un orden topologico
	require
		not has_cycle
	local
		ii: ITERATOR[VERTEX[K]]
	do
		create {LINKED_LIST[VERTEX[K]]} Result.make (1, 0)
		from
			ii := get_new_iterator
		until
			ii.is_off or else valency (ii.item) = 0
		loop
			ii.next
		end
		from
			ii := get_new_iterator_dfs (ii.item)
		until
			ii.is_off
		loop
			Result.add_first (ii.item)
			ii.next
		end
	end

feature -- Output

	output_header: STRING is "digraph"

	output_unweighted_edge (v1, v2: VERTEX[K]): STRING is
	do
		Result := v1.index.to_string + " -> " + v2.index.to_string
	end

end -- class DIRECTED_GRAPH[K, E]
