class ITERATOR_ORDERED_EDGES[W->DOUBLE, K]

inherit ITERATOR[WEIGHTED_EDGE[W, K]]

creation make

feature {NONE}

	graph: WEIGHTED_GRAPH[W, K, EDGES[K]]

	queue: PRIORITY_QUEUE[WEIGHTED_EDGE[W, K]]

feature

	make(g: like graph) is
	do
		graph := g
		create queue.make
		start
	end

	start is
	local
		ii: ITERATOR[WEIGHTED_EDGE[W, K]]
	do
		queue.clear
		from
			ii := graph.get_new_iterator_on_edges
		until
			ii.is_off
		loop
			queue.add (ii.item)
			ii.next
		end
	end

	is_off: BOOLEAN is
	do
		Result := queue.is_empty
	end

	item: WEIGHTED_EDGE[W, K] is
	do
		Result := queue.item
	end

	next is
	do
		queue.remove
	end

end
