class NETWORK[K, W->DOUBLE]

inherit
	WEIGHTED_DIRECTED_GRAPH_MATRIX[K, W]

feature -- Access

	source, sink: VERTEX[K]
		-- fuente y resumidero

	set_sink (v: VERTEX[K]) is
	require
		has_vertex (v)
	do
		sink := v
	end

	set_source (v: VERTEX[K]) is
	require
		has_vertex (v)
	do
		source := v
	end

feature -- Algorithms

	get_max_flow: FLOW[K, W] is
		-- obtiene el flujo maximal
	local
		aux: LAYERED_NETWORK[K, W]
	do
		create Result.from_network (Current)
		from
			aux := get_auxiliar (Result)
		until
			aux.count = 0
		loop
			Result.augment (aux.get_max_flow)
			aux := get_auxiliar (Result)
		end
	end

feature {NONE} -- Internal

	get_auxiliar (f: FLOW[K, W]): LAYERED_NETWORK[K, W] is
		-- obtiene el network auxiliar
	do
		create Result.from_network (f)
	end

end -- class NETWORK[K, W]
