expanded class SIMPLE_INPUT_OUTPUT

inherit INPUT_OUTPUT[INTEGER]

feature -- Input

	simple_read (stream: INPUT_STREAM; graph: SIMPLE_GRAPH[EDGES[INTEGER]]) is
	local
		vertices: DICTIONARY[VERTEX[K], K]
		source, target: VERTEX[K]
		words: ARRAY[STRING]
		edge: EDGE[K]
		w_edge: WEIGHTED_EDGE[INTEGER, K]
		label: K
	do
		create vertices.make
		stream.read_integer
		
		-- busca el comienzo del grafo
		from
			create words.make (1, 0)
		until
			words.count > 0 and then (words@1).has_substring ("graph")
		loop
			read_line (stream, words)
		end
		-- se fija si es dirigido
		if equal(words@1, "graph") then
			-- es no dirigido
		else
			-- es dirigido
		end
		-- agrega nodos y aristas
		from
			read_line (stream, words)
		until
			stream.end_of_input or words.count <= 0
		loop
			if words.count > 1 and then not equal (words@2, "label") then
				-- es arista
				source := vertices.at (words@1)
				target := vertices.at (words@2)
				if words.count > 3 then
					-- con peso
					create w_edge.make (source, target, (words@4).to_integer)
					graph.put_edge (w_edge)
				else
					-- sin peso
					create edge.make (source, target)
					graph.put_edge (edge)
				end
			else
				-- es nodo
				if words.count > 1 then
					-- tiene label
					label ?= words@3
					graph.add (label)
				else
					-- no tiene label
					graph.add (Void)
				end
				vertices.put (graph.last_vertex_added, words @ 1)
			end
			read_line (stream, words)
		end
	end

end -- class SIMPLE_INPUT_OUTPUT
