deferred class SIMPLE_VERTICES
	-- una coleccion simple de vertices

inherit
	VERTICES_SET[INTEGER]
		export {NONE} add, last_vertex_added
		redefine create_vertex, has_vertex, has, fast_has, vertex_of, fast_vertex_of
		end

feature {NONE} -- Creation

	simple_make (l, u: INTEGER) is
		-- inicializa la coleccion de `l' a `u'
	do
		lower := l
		upper := u
		count := u - l + 1
	ensure
		count = n
	end

feature -- access

	count: INTEGER
		-- cantidad de vertices

feature -- bounds

	lower, upper: INTEGER

feature -- Looking and searching

	get_new_iterator: ITERATOR[SIMPLE_VERTEX] is
	do
		create {SIMPLE_ITERATOR_VERTICES}Result.make (Current)
	end

	has_vertex (v: SIMPLE_VERTEX): BOOLEAN is
	do
		Result := v.hash_code.in_range (lower, upper)
	end

	simple_has_vertex (v: INTEGER): BOOLEAN is
	do
		Result := v.in_range (lower, upper)
	end

	has(k: INTEGER): BOOLEAN is
	do
		Result := simple_has_vertex (k)
	end

	fast_has(k: INTEGER): BOOLEAN is
	do
		Result := simple_has_vertex (k)
	end

	vertex_of (k: INTEGER): SIMPLE_VERTEX is
	do
		Result := create_vertex (k)
	end

	fast_vertex_of (k: INTEGER): SIMPLE_VERTEX is
	do
		Result := create_vertex (k)
	end

feature {NONE} -- Implementation

	create_vertex (k: INTEGER): SIMPLE_VERTEX is
	do
		create Result.make (k)
	end

end -- class SIMPLE_VERTICES
