deferred class BIPARTITE_VERTICES[K]

inherit
	VIEW[VERTICES[K]]
	VERTICES[K]
		export {NONE} add
		end

feature {NONE} -- Creation

	make is
	do
		set_model (x)
		set_model (y)
	end

feature -- Access

	x, y: expanded VERTICES_SET[K]

	count: INTEGER is
	do
		Result := x.count + y.count
	end

	last_vertex_added: VERTEX[K] is
	do
		Result := x.last_vertex_added
		if Result = Void then
			Result := y.last_vertex_added
		end
	end

feature -- Looking and searching

	get_new_iterator: ITERATOR[VERTEX[K]] is
	do
		create {ITERATOR_UNION[VERTEX[K]]}Result.make (x.get_new_iterator, y.get_new_iterator)
	end

	has_vertex (v: VERTEX[K]): BOOLEAN is
	do
		Result := x.has_vertex (v) or y.has_vertex (v)
	end

feature -- View

	on_model_change is
	do
		notify_views
	end

end -- class BIPARTITE_VERTICES[K]
