class VERTICES_SET[K]
	-- un VERTICES implementado con SET

inherit VERTICES[K]

creation make

feature {NONE} -- Creation

	make is
	do
		make_model
		create verts.make
	end

feature -- Vertex

	last_vertex_added: VERTEX[K]

	count: INTEGER is
	do
		Result := verts.count
	end

feature -- Looking and searching

	get_new_iterator: ITERATOR[VERTEX[K]] is
	do
		Result := verts.get_new_iterator
	end

	has_vertex(v: VERTEX[K]): BOOLEAN is
	do
		Result := verts.has (v)
	end

feature {VERTEX} -- Internal

	add_vertex (v: VERTEX[K]) is
	do
		verts.add (v)
		last_vertex_added := v
		notify_views
	end

feature {NONE} -- Internal

	verts: SET[VERTEX[K]]

	create_vertex (k: K): VERTEX[K] is
	do
		Result := create {VERTEX_INDEX[K]}.make (k, verts.count + 1)
	end

invariant

	verts /= Void

end -- class VERTICES_SET[K]
